Skip to content

Vehicles

Manage vehicles and get current vehicle status.

Get List of Vehicles

Lists Vehicles in account. Restricted based on API user's group permissions.

GET

http
https://api.zubiecar.com/api/v2/zinc/vehicles

Query Parameters

PropertyTypeDescription
qstringSearch vehicles by nickname or full VIN.
tag_keysArray of stringsRestrict results to include only vehicles with these tag keys. Multiple tag values may be provided, treated as an OR in filter.
group_keysArray of stringsRestrict results to include only vehicles that are members of these groups (or their descendants).
cursorstringThe cursor string used for pagination, signifying the object ID where to start the results.
sizestringThe number of results to return per call. Defaults to 50 if not provided.
expandArray of stringsDefault: []
Items Enum: tags, groups, devices, last_trip
Optional list of expanded properties to include in results.
Sample response 200
json
{
  "vehicles": [
    {
      "active_trouble_code_count": 1,
      "active_trouble_codes": [
        {
          "code": "P9876",
          "description": "Engine Load Control Fault",
          "detailed_description": "Modern vehicles often utilize systems to optimize engine load for efficiency and emissions compliance. When the ECU identifies a malfunction within this system, it may trigger code P9876.",
          "reported": "2025-04-22T14:18:12-05:00",
          "severity": 2
        }
      ],
      "battery_charge_level": null,
      "battery_low": false,
      "battery_volts": 13.271,
      "created": "2020-03-10T19:15:28.501699+00:00",
      "device_keys": [
        "agpzZ2V2aWNlc2VydmljZXILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZksM",
        "agpzZ2V2aWNlc2VydmljZXILEgZEZXZpY2UiFnprTmRRMkJYenRoR0NtcGZVbVViQww"
      ],
      "driver": {
        "first_name": "Jordan",
        "key": "agpzZ2V2aWNlc2VydmljZXALEgRVc2VyIhZHcHczWkRkVnhHVlFoU3FHTWFTb0xLDA",
        "last_name": "Murphy",
        "profile_image": "https://res.cloudinary.com/random/image/upload/default_profile_image.gif"
      },
      "fuel_economy": 23.5,
      "fuel_economy_um": "mpg",
      "fuel_level": 84,
      "fuel_level_timestamp": "2025-06-29T12:01:00+00:00",
      "fuel_type": null,
      "group_keys": [],
      "image_url": "https://res.cloudinary.com/random/image/upload/v1654210123/demoimage.jpg",
      "key": "agpzZ2V2aWNlc2VydmljZXJxLEgdBY2NvdW50IhZTRkd4clp3Wm1CWVJFUlU4R2pTNW9iDAsSA0NhciILZnZ4dFZlV2R2ZngM",
      "last_trip_key": "agpzZ2V2aWNlc2VydmljZQILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZk0MCxIEVHJpcCIWNkZEWjRrU2d0aGdRVUVCU0NYY3ZVM2YwRww",
      "make_name": "Mazda",
      "mil_status": "green",
      "model_name": "CX-5",
      "model_year": 2017,
      "nickname": "321579",
      "odometer": 134922,
      "odometer_is_actual": false,
      "odometer_timestamp": "2025-07-01T14:52:47.000000+00:00",
      "odometer_um": "mi",
      "plate_expiration": "2025-09-30",
      "plate_jurisdiction": null,
      "plate_number": "ZZZ-789",
      "primary_driver_key": "agpzZ2V2aWNlc2VydmljZXALEgRVc2VyIhZHcHczWkRkVnhHVlFoU3FHTWFTb0xLDA",
      "range_remaining": 16.0, 
      "range_remaining_um": "mi",
      "reported_vin": "1HGCM82633A004352",
      "schedule_key": null,
      "style_fuel_capacity_gal": 14.5,
      "style_fuel_economy": 23.5,
      "style_fuel_economy_um": "mpg",
      "style_fuel_type": "Gasoline (Regular)",
      "style_id": "500123456",
      "style_provider": "datahub",
      "style_url": null,
      "tag_keys": [],
      "tpms_left_front_psi": 31.618226825185605,
      "tpms_left_front_timestamp": "2026-01-01T14:43:36+00:00",
      "tpms_left_rear_psi": 32.19837777610644,
      "tpms_left_rear_timestamp": "2026-01-01T14:44:06+00:00",
      "tpms_right_front_psi": 32.19837777610644,
      "tpms_right_front_timestamp": "2026-01-01T14:43:51+00:00",
      "tpms_right_rear_psi": 32.48845325156686,
      "tpms_right_rear_timestamp": "2026-01-01T14:44:06+00:00",
      "trim_name": "Sport Edition",
      "updated": "2025-07-01T16:10:29.219000+00:00",
      "vehicle_location": {
        "heading": null,
        "key": "agpzZ2V2aWNlc2VydmljZXJpYyLEgtDYXJMb2NhdGlvbiIWOERNaXY2d0ZuV3VjWDlUdWdqOTcyVQw",
        "motion_status": "stopped",
        "point": {
          "lat": 35.2271,
          "lon": -80.8431
        },
        "range_remaining": 16.0,
        "range_remaining_um": "mi",
        "speed_mph": null,
        "timestamp": "2025-07-01T09:32:11-05:00"
      },
      "vin": "1HGCM82633A004352"
    }
  ]
}

Create Vehicle

Creates a Vehicle.

POST

http
https://api.zubiecar.com/api/v2/zinc/vehicles

Request Body Schema

PropertyTypeDescription
fuel_economystringUser defined vehicle fuel economy.
fuel_typestringUser defined vehicle fuel type, overrides style info.
image_urlstringURL of vehicle image. If not defined, falls back to style-based image.
nicknamestring requiredVehicle nickname.
odometerintegerThe current odometer reading.
odometer_umstringUnit of measure for odometer, mi or km.
primary_driver_keystringThe user key to set as the primary driver of the vehicle attached to the device. Optional.
schedule_keystringThe (optional) schedule associated with this vehicle. See Vehicle Schedules. Can be cleared by posting empty value.
tag_keysArray of stringsTags assigned to the vehicle. Multiple values can be provided in the array. Can be cleared by posting empty value.
group_keysstringGroup assigned to the vehicle. If groups aren't used, or vehicle belongs to the account (not a sub-group), leave empty. Only ONE group should be assigned to a vehicle. Can be cleared by posting empty value.
vinstring requiredVehicle Identification Number, either detected by system or entered by user.
Sample request body
json
{
  "fuel_economy": 23.4,
  "fuel_type": "unleaded",
  "image_url": "http://image.server.com/image_path/image_file.png",
  "nickname": "VAN 123",
  "odometer": 28212,
  "odometer_um": "mi",
  "primary_driver_key": "SampleKey",
  "schedule_key": "SampleKey",
  "tag_keys": [
    "SampleKey1",
    "SampleKey2"
  ],
  "group_keys": "SampleKey",
  "vin": "JTEBU17R848028574"
}
Sample response 201
json
{
    "active_trouble_code_count": 0,
    "active_trouble_codes": [],
    "battery_charge_level": null,
    "battery_low": false,
    "battery_volts": null,
    "created": "2025-01-01T00:00:00.000000+00:00",
    "device_keys": [],
    "devices": [],
    "driver": null,
    "fuel_economy": 23.4,
    "fuel_economy_um": "mpg",
    "fuel_level": null,
    "fuel_level_timestamp": null,
    "fuel_type": "unleaded",
    "group_keys": [],
    "groups": [],
    "image_url": "https://res.cloudinary.com/zubie/image/fetch/https://d1ypc8j62c29y8.cloudfront.net/fullsize/d/1/a/9ea2d7debba8bf000762fac8ca80914fc44dfa1d.jpg",
    "key": "agpzfnp1YmllY2FycjcLEgdBY2NkdW55IhZPRmRva0RrYTg0V0xVGGI5ZkhKM59iDAfSA0NhciILTG9GaXJ2NkZkOLQM",
    "last_trip": null,
    "last_trip_key": null,
    "make_name": "Toyota",
    "mil_status": null,
    "model_name": "4Runner",
    "model_year": 2004,
    "nickname": "VAN 123",
    "odometer": 28212,
    "odometer_is_actual": false,
    "odometer_timestamp": "2025-01-01T00:00:00.000000+00:00",
    "odometer_um": "mi",
    "plate_expiration": null,
    "plate_jurisdiction": null,
    "plate_number": null,
    "primary_driver_key": null,
    "reported_vin": null,
    "schedule_key": null,
    "style_fuel_capacity_gal": 23.0,
    "style_fuel_economy": 17.0,
    "style_fuel_economy_um": "mpg",
    "style_fuel_type": "Gasoline",
    "style_id": "100336294",
    "style_provider": "dataone",
    "style_url": null,
    "tag_keys": [],
    "tags": [],
    "tpms_left_front_psi": null,
    "tpms_left_front_timestamp": null,
    "tpms_left_rear_psi": null,
    "tpms_left_rear_timestamp": null,
    "tpms_right_front_psi": null,
    "tpms_right_front_timestamp": null,
    "tpms_right_rear_psi": null,
    "tpms_right_rear_timestamp": null,
    "trim_name": "Limited",
    "updated": "2025-01-01T00:00:00.000000+00:00",
    "vehicle_location": null,
    "vin": "JTEBU17R848028574"
}

Get a Vehicle

Retrieve a specific vehicle by key.

GET

http
https://api.zubiecar.com/api/v2/zinc/vehicle/{vehicle_key}
Sample response 200
json
{
  "active_trouble_code_count": 1,
  "active_trouble_codes": [
    {
      "code": "P9876",
      "description": "Engine Load Control Fault",
      "detailed_description": "Modern vehicles often utilize systems to optimize engine load for efficiency and emissions compliance. When the ECU identifies a malfunction within this system, it may trigger code P9876.",
      "reported": "2025-04-22T14:18:12-05:00",
      "severity": 2
    }
  ],
  "battery_charge_level": null,
  "battery_low": false,
  "battery_volts": 13.271,
  "created": "2020-03-10T19:15:28.501699+00:00",
  "device_keys": [
    "agpzZ2V2aWNlc2VydmljZXILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZksM",
    "agpzZ2V2aWNlc2VydmljZXILEgZEZXZpY2UiFnprTmRRMkJYenRoR0NtcGZVbVViQww"
  ],
  "devices": [
      {
          "disconnected_timestamp": null,
          "is_connected": true,
          "key": "agpzZ2V2aWNlc2VydmljZXILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZksM",
          "last_transmission": "2026-01-01T18:06:45.844443+00:00",
          "serial": "72634FB01D9162L"
      }
  ],
  "driver": {
    "first_name": "Jordan",
    "key": "agpzZ2V2aWNlc2VydmljZXALEgRVc2VyIhZHcHczWkRkVnhHVlFoU3FHTWFTb0xLDA",
    "last_name": "Murphy",
    "profile_image": "https://res.cloudinary.com/random/image/upload/default_profile_image.gif"
  },
  "fuel_economy": 23.5,
  "fuel_economy_um": "mpg",
  "fuel_level": 84,
  "fuel_level_timestamp": "2025-06-29T12:01:00+00:00",
  "fuel_type": null,
  "group_keys": [],
  "groups": [],
  "image_url": "https://res.cloudinary.com/random/image/upload/v1654210123/demoimage.jpg",
  "key": "agpzZ2V2aWNlc2VydmljZXJxLEgdBY2NvdW50IhZTRkd4clp3Wm1CWVJFUlU4R2pTNW9iDAsSA0NhciILZnZ4dFZlV2R2ZngM",
  "last_trip": {
    "end_point": null,
    "key": "agpzZ2V2aWNlc2VydmljZQILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZk0MCxIEVHJpcCIWNkZEWjRrU2d0aGdRVUVCU0NYY3ZVM2YwRww",
    "start_point": {
      "address": {
        "city": "Bloomington",
        "state": "MN",
        "street": "8120 Penn Ave S",
        "zipcode": "55431"
      },
      "place": {
        "key": "agpzfnp1YmllLXFhcjwfEgdBY2NvdW50IhZTblV2RjhIdWY5b2R1UTJybnZSS2RVDAsSCEdlb2ZlbmLlIgtoP5ljSzNYYnN7TBp",
        "name": "Headquarters"
      },
      "point": {
        "lat": 44.8559,
        "lon": -93.3107
      },
      "range_remaining": null,
      "range_remaining_um": "mi",
      "timestamp": "2026-01-01T02:36:13.894000+00:00"
    }
  },
  "last_trip_key": "agpzZ2V2aWNlc2VydmljZQILEgZEZXZpY2UiFlR2QWxvckV3NlRUV0dDbGFFbnBQZk0MCxIEVHJpcCIWNkZEWjRrU2d0aGdRVUVCU0NYY3ZVM2YwRww",
  "make_name": "Mazda",
  "mil_status": "green",
  "model_name": "CX-5",
  "model_year": 2017,
  "nickname": "321579",
  "odometer": 134922,
  "odometer_is_actual": false,
  "odometer_timestamp": "2025-07-01T14:52:47.000000+00:00",
  "odometer_um": "mi",
  "plate_expiration": "2025-09-30",
  "plate_jurisdiction": null,
  "plate_number": "ZZZ-789",
  "primary_driver_key": "agpzZ2V2aWNlc2VydmljZXALEgRVc2VyIhZHcHczWkRkVnhHVlFoU3FHTWFTb0xLDA",
  "range_remaining": 16.0, 
  "range_remaining_um": "mi",
  "reported_vin": "1HGCM82633A004352",
  "schedule_key": null,
  "style_fuel_capacity_gal": 14.5,
  "style_fuel_economy": 23.5,
  "style_fuel_economy_um": "mpg",
  "style_fuel_type": "Gasoline (Regular)",
  "style_id": "500123456",
  "style_provider": "datahub",
  "style_url": null,
  "tag_keys": [],
  "tpms_left_front_psi": 31.618226825185605,
  "tpms_left_front_timestamp": "2026-01-01T14:43:36+00:00",
  "tpms_left_rear_psi": 32.19837777610644,
  "tpms_left_rear_timestamp": "2026-01-01T14:44:06+00:00",
  "tpms_right_front_psi": 32.19837777610644,
  "tpms_right_front_timestamp": "2026-01-01T14:43:51+00:00",
  "tpms_right_rear_psi": 32.48845325156686,
  "tpms_right_rear_timestamp": "2026-01-01T14:44:06+00:00",
  "trim_name": "Sport Edition",
  "updated": "2025-07-01T16:10:29.219000+00:00",
  "vehicle_location": {
    "heading": null,
    "key": "agpzZ2V2aWNlc2VydmljZXJpYyLEgtDYXJMb2NhdGlvbiIWOERNaXY2d0ZuV3VjWDlUdWdqOTcyVQw",
    "motion_status": "stopped",
    "point": {
      "lat": 35.2271,
      "lon": -80.8431
    },
    "speed_mph": null,
    "timestamp": "2025-07-01T09:32:11-05:00"
  },
  "vin": "1HGCM82633A004352"
}

Update Vehicle

Update a Vehicle.

POST

http
https://api.zubiecar.com/api/v2/zinc/vehicle/{vehicle_key}

Request Body Schema

PropertyTypeDescription
fuel_economystringUser defined vehicle fuel economy.
fuel_typestringUser defined vehicle fuel type, overrides style info.
image_urlstringURL of vehicle image. If not defined, falls back to style-based image.
nicknamestringVehicle nickname.
odometerintegerThe current odometer reading.
odometer_umstringUnit of measure for odometer, mi or km.
primary_driver_keystringThe user key to set as the primary driver of the vehicle attached to the device. Optional.
schedule_keystringThe (optional) schedule associated with this vehicle. See Vehicle Schedules. Can be cleared by posting empty value.
tag_keysArray of stringsTags assigned to the vehicle. Multiple values can be provided in the array. Can be cleared by posting empty value.
group_keysstringGroup assigned to the vehicle. If groups aren't used, or vehicle belongs to the account (not a sub-group), leave empty. Only ONE group should be assigned to a vehicle. Can be cleared by posting empty value.
vinstringVehicle Identification Number, either detected by system or entered by user.
Sample request body
json
{
  "fuel_economy": 23.4,
  "fuel_type": "unleaded",
  "image_url": "http://image.server.com/image_path/image_file.png",
  "nickname": "VAN 123",
  "odometer": 28212,
  "odometer_um": "mi",
  "primary_driver_key": "SampleKey",
  "schedule_key": "SampleKey",
  "tag_keys": [
    "SampleKey1",
    "SampleKey2"
  ],
  "group_keys": "SampleKey",
  "vin": "JTEBU17R848028574"
}
Sample response 200
json
{
    "active_trouble_code_count": 0,
    "active_trouble_codes": [],
    "battery_charge_level": null,
    "battery_low": false,
    "battery_volts": null,
    "created": "2025-01-01T00:00:00.000000+00:00",
    "device_keys": [],
    "devices": [],
    "driver": null,
    "fuel_economy": 23.4,
    "fuel_economy_um": "mpg",
    "fuel_level": null,
    "fuel_level_timestamp": null,
    "fuel_type": "unleaded",
    "group_keys": [],
    "groups": [],
    "image_url": "https://res.cloudinary.com/zubie/image/fetch/https://d1ypc8j62c29y8.cloudfront.net/fullsize/d/1/a/9ea2d7debba8bf000762fac8ca80914fc44dfa1d.jpg",
    "key": "agpzfnp1YmllY2FycjcLEgdBY2NkdW55IhZPRmRva0RrYTg0V0xVGGI5ZkhKM59iDAfSA0NhciILTG9GaXJ2NkZkOLQM",
    "last_trip": null,
    "last_trip_key": null,
    "make_name": "Toyota",
    "mil_status": null,
    "model_name": "4Runner",
    "model_year": 2004,
    "nickname": "VAN 123",
    "odometer": 28212,
    "odometer_is_actual": false,
    "odometer_timestamp": "2025-01-01T00:00:00.000000+00:00",
    "odometer_um": "mi",
    "plate_expiration": null,
    "plate_jurisdiction": null,
    "plate_number": null,
    "primary_driver_key": null,
    "reported_vin": null,
    "schedule_key": null,
    "style_fuel_capacity_gal": 23.0,
    "style_fuel_economy": 17.0,
    "style_fuel_economy_um": "mpg",
    "style_fuel_type": "Gasoline",
    "style_id": "100336294",
    "style_provider": "dataone",
    "style_url": null,
    "tag_keys": [],
    "tags": [],
    "tpms_left_front_psi": 31.618226825185605,
    "tpms_left_front_timestamp": "2026-01-01T14:43:36+00:00",
    "tpms_left_rear_psi": 32.19837777610644,
    "tpms_left_rear_timestamp": "2026-01-01T14:44:06+00:00",
    "tpms_right_front_psi": 32.19837777610644,
    "tpms_right_front_timestamp": "2026-01-01T14:43:51+00:00",
    "tpms_right_rear_psi": 32.48845325156686,
    "tpms_right_rear_timestamp": "2026-01-01T14:44:06+00:00",
    "trim_name": "Limited",
    "updated": "2025-01-01T00:00:00.000000+00:00",
    "vehicle_location": null,
    "vin": "JTEBU17R848028574"
}

Delete Vehicle

Deactivates vehicle from the account.

DELETE

http
https://api.zubiecar.com/api/v2/zinc/vehicle/{vehicle_key}

Path Parameters

PropertyTypeDescription
vehicle_keyrequiredUnique vehicle key.

Get Nearby Vehicle List

Get list of nearby vehicles, using a given GPS point. Restricted based on API user's group permissions.

GET

http
https://api.zubiecar.com/api/v2/zinc/vehicles/nearby

Query Parameters

PropertyTypeDescription
latstringLatitude of the point.
lotstringLongitude of the point.
cursorstringThe cursor string used for pagination, signifying the object ID where to start the results.
sizestringThe number of results to return per call. Defaults to 5 if not provided.
Sample response 200
json
{
  "vehicles": [
    {
      "distance_in_miles": 25.1,
      "battery_volts": 12.4,
      "fuel_level": 25,
      "key": "SampleKey",
      "nickname": "VAN 123",
      "odometer": 28212,
      "vehicle_location": {
        "heading": 280,
        "image_url": "http://image.server.com/image_path/image_file.png",
        "key": "SampleKey",
        "point": {
          "lat": 40.74778,
          "lon": -73.99889
        },
        "motion_status": "stale",
        "speed_mph": 54,
        "timestamp": "2018-02-20 12:00:00"
      }
    }
  ]
}

List Vehicle Battery History

Get list of battery levels as reported through vehicle heartbeats. Heartbeat events are sent at the beginning of a trip, and periodically when the vehicle is not in a trip.

GET

http
https://api.zubiecar.com/api/v2/zinc/vehicle/{vehicle_key}/battery-history

Path Parameters

PropertyTypeDescription
vehicle_keyrequiredUnique vehicle key.

Query Parameters

PropertyTypeDescription
cursorstringThe cursor string used for pagination, signifying the object ID where to start the results.
sizestringThe number of results to return per call. Defaults to 50 if not provided.
sincestringLook for battery levels reported on Heartbeats starting on or after this time. ISO8601 formatted datetime, e.g. 2014-10-01T00:00:00-06:00 (optional). Default is now UTC - 7 days.
untilstringLook for battery levels reported on Heartbeats starting on or before this time. ISO8601 formatted datetime (optional). Default uses now UTC.
order_bystringDetermines timestamp order to return heartbeats, asc or desc (optional). Defaults to desc.
Sample response 200
json
{
  "results": [
    {
      "ambient_temperature": 71,
      "battery_level": 13.1,
      "point": {
        "lat": 40.74778,
        "lon": -73.99889
      },
      "timestamp": "2018-02-20 12:00:00"
    }
  ]
}